<h1 align="center">音·创 Musicreater</h1>

<h2 align="center">库版 Package Version</h2>

<p align="center">
<img width="128" height="128" src="https://s1.ax1x.com/2022/05/06/Ouhghj.md.png" >
</p>

# 新手答疑指南

**考虑到某些用户电脑技术不是特别先进，且对这个项目充满了好奇心，但是又了解的不是很充分，
为此，我特别在这里写一份文档，解答各位的好奇心。放心，本文件全程中文，英文版本随后更新！**

## 第一部分 关于音·创的作用

### 1.1 音·创简介

音·创 Musicreater 是一款免费开源的 **《我的世界：基岩版》** 音乐制作软件

音·创 库版 (Musicreater Package Version) 是一款免费开源的针对 **《我的世界：基岩版》** 的midi音乐转换库

音·创 采用的是**带有特殊条款的Apache2.0**开源协议，详情请见[这里](https://gitee.com/EillesWan/Musicreater/blob/master/LICENSE.md)。

音·创
目前已经具备较为完善的**教程**，如果你还不知道音·创有教程，请点击
[
这里](https://gitee.com/EillesWan/Musicreater/blob/pkgver/docs/%E5%8A%9F%E8%83%BD%E4%BD%BF%E7%94%A8%E8%AF%B4%E6%98%8E.md)。

### 1.2 音·创到底目前有什么功能？
 * - [x] 支持导入.mid文件
 * - [x] 支持写入.mcpack文件
 * - [x] 支持写入.bdx文件


 * 不支持导入.mp3 .mp4 .wav等音频流文件

## 第二部分 关于格式的问题

### 2.1 关于.mid格式
其实对于经常玩音乐电子制作的朋友们来说，mid格式并不陌生，这里我简单介绍一下。

> mid格式是由MIDI继承而来。MID文件并不是一段录制好的声音，而是记录声音的信息，然后再告诉声卡如何再现音乐的一组指令。
> 这样一个MIDI文件每存1分钟的音乐只用大约5～10KB。今天，MID文件主要用于原始乐器作品、流行歌曲的业余表演、游戏音轨以及电子贺卡等。
> 
> ——百度百科
> 
> MIDI 音乐，保存在电脑上，就是 *.mid 类型的文件。和一般意义上的“音乐”不同，mid 类型的音乐通常并不是可直接发行供大众欣赏的音乐，
> 它更像是一种音乐创作者使用的工程文件。它没有歌词，不含有人类语言。如果说五线谱是给人类阅读的乐谱，
> MIDI音乐文件便是给计算机或其他电子设备使用的乐谱。对于“音乐”这个世界来说，它微不足道，却又是现代数字音乐的基石。虽不为大众所知，
> 但在 MIDI 音乐爱好者眼中，它却是非常有意思的东西。有了 MIDI 音乐技术和一台电脑，基本就等于拥有了一个乐队，加上相关的音乐知识，
> 就可以自己指挥这个“乐队”，创作音乐作品了！
> 同时，MIDI 技术由于数据结构简单，又与音乐有关，也成为了部分技术极客的爱好。有人使用MIDI技术+Arduino开源硬件制作了架子鼓，
> 有人通过分析大量MIDI乐曲结构，设计了人工智能作曲软件，还有更酷的人使用MIDI音乐制作了随节奏变幻的特斯拉线圈！
> 在MIDI 音乐的世界里，汇聚了一批喜欢音乐又热爱技术的人。我们有理由相信，玩MIDI音乐的你，定是多才多艺的。
> 
> ——midishow.com

**所以，mid文件的本质是电子乐谱，而不是记录声音波形文件的.mp3/.wav/.m4a等等文件！**

### 2.2 关于.mid格式的获取

通过刚刚的介绍，你可能已经发现，*.mid文件因为受众并不多而并没有被广泛熟知，因而你之前可能完全没见过这个文件，更何况要弄一首自己心仪的歌了。

这里介绍几个获取.mid格式的方法：

1. 最简单的方法就是成为一个作编曲的人，当然，很多人做不到这一点，但是有必要提到这一点，当你在下面的渠道中都无法获得想要的文件时，
你应该考虑是不是需要自己创作内容，或者，请别人帮你创作内容。
2. 当你没有这样的文件时，问问别人或者从群里下在公告的免费的也是个思路，不过这个办法通常使用次数有限。
3. 自己找mid：现在，我将给你提供一个完整的找mid的方法，请认真学习：
    **1.** 首先你需要在www.midishow.com中注册一个账号，并不复杂，你可能只需要一个QQ号。
    **2.** 登录你的账号，主界面应该如下图所示：
       <img src="https://foruda.gitee.com/images/1672644995747340749/36c9c143_10062986.png">
    **3.** 在显眼的搜索框中，输入你想要的歌曲名称，接下来的教程，我以`夜空中最亮的星`这首歌及它的mid来演示下载流程。点击搜索框，完成这一步。
       <img src="https://foruda.gitee.com/images/1672645340943813483/44d0db69_10062986.png">
    **4.** 接下来看到搜索结果如下，你可以点进去一个听听，决定你是否要下载；也有可能你什么都没搜到，那你就得换首歌或者换个途径了。
       <img src="https://foruda.gitee.com/images/1672645574402099694/6b7e18e5_10062986.png">
    **5.** 点击播放按钮试听，网站上的效果可能一般，但是会听音乐的人应该很快就能决定你是否需要下载这个音乐。如果需要下载，你可以进行到下一步，
    如果不行，那你可以退回刚刚的页面换一个。
       <img src="https://foruda.gitee.com/images/1672645752246438160/47cead78_10062986.png">
    **6.** 翻到最下面，如图，你可以对这首歌进行打分，打分可以使积分+1，建议打5分；你可以对这首歌进行评论，一次有意义的评论可以+3分。
    下载一首歌需要-3积分，如果你先完成了这两项操作再下载，那你还会再赚1积分。所以推荐这样做！
       <img src="https://foruda.gitee.com/images/1672646433045265565/26ea29b2_10062986.png">
    **完成后会像这样：** 
       <img src="https://foruda.gitee.com/images/1672646242419857480/5e8809b8_10062986.png">
    **7.** 接下来下载，往上翻网页，找到这个标识，然后单击。
       <img src="https://foruda.gitee.com/images/1672646275215822535/63b402db_10062986.png">
    **8.** 确认完毕后点击下载。
       <img src="https://foruda.gitee.com/images/1672646309787744490/f459adac_10062986.png">
    **9.** 完成下载，如图：
       <img src="https://foruda.gitee.com/images/1672646335942429563/2449ed0b_10062986.png">
4. 使用mp3转换为mid的工具：不得不说，科技的进步带来了许多便利，让这样困难的事情也变得简单。如果上述方法仍然没有解决你的问题，
那么你可以在下一章节中找到有关这个途径的说明。

### 2.3 .mp3格式转换为.mid格式

**注意，使用这个技术有一定难度，酌情使用！**

概述：mp3转mid需要把**模拟的波形频谱信号转为数字乐谱信号**，这个过程**一定有损失**。

请各位以后不要在答疑群中问类似于我这个转换效果为什么不好这样的问题，谢谢。

如果直接用**widi**的话相当于对声音进行了**傅里叶变换**，你确实可以分离出其中的音高，但是效果在不同情况下差异较大，
尤其是有架子鼓啊啥的玩也的时候，比较**差**。
（[widi工具链接](https://pan.baidu.com/s/1j_Jui0piQ6rMOXM0GJtqTg) 提取码：b0lw ）

**如果只有钢琴的谱子需要分离，有一个完美的选择**：[这里](https://zhuanlan.zhihu.com/p/270999354)

如果不然有其他的乐器也需要分离，那么可能就有点困难，像cakewalk就确实也可以吧音频变成mid，但是可能要
**先把原MP3分离成人声音轨、贝斯音轨等再傅里叶变换。**

当然我也可能了解的不全，没准现在已经有传新的技术可以分离的更好了，那就太棒了！(〃'▽'〃)

另外，我们开发者也象征性的找了一些mp3转mid的网站，我们没使用过，不担保效果。
[https://www.serocs.cn/transcription/](https://www.serocs.cn/transcription/)

同时，midishow论坛里有一些大佬也提供了解决方案，看看他们的发言也是一个不错的选择。

我就只给个论坛链接了，经常有人问这种问题，你可以去那里随便找到一篇帖子看看。
[论坛](https://www.midishow.com/question)

### 2.4 输出格式的问题

在前面说到，输出主要有`.mcpack`和`.bdx`文件的输出，接下来我会围绕这两个文件进行简单的说明。

#### 2.4.1 .mcpack是什么

输出.mcpack文件其实对于一个**资深基岩版我的世界玩家**应该并不陌生。

.mcpack文件其实就是我的世界基岩版的附加包，里面一般分为行为包和材质包

我们生成的命令组属于**行为包** (下图就是一个例子)

<img src="https://foruda.gitee.com/images/1672647779755793187/884abaa9_10062986.png">

如果你是国际电脑版基岩玩家就像我一样，是可以直接打开这个文件，并将这个包导入我的世界的。

关于怎么使用，请看[**这里**](https://gitee.com/EillesWan/Musicreater/blob/pkgver/docs/%E7%94%9F%E6%88%90%E6%96%87%E4%BB%B6%E7%9A%84%E4%BD%BF%E7%94%A8%E8%AF%B4%E6%98%8E.md)。

#### 2.4.2 .bdx是什么

.bdx 文件其实是FastBuilder这款软件的结构文件，可以导入到我的世界。

由于这不属于官方文件，且我并不是很熟悉这个结构，所以请对这个格式有问题的好兄弟加一下QQ群，问问群里负责导入的大佬。

## 第三部分 关于其他问题

**由于开发者们都很忙，群友们的耐心也都有限，所以恳请大家提出有意义的问题。这里附一个关于提问方法的链接，大家可以看看。**

[提问的智慧](https://github.com/tvvocold/How-To-Ask-Questions-The-Smart-Way)

希望不要我把这个文件在聊天中甩给你，那说明我可能已经没有耐心了。

看完这份说明，如果你打算开始使用我们的工具的话，请移步至[这里](https://gitee.com/EillesWan/Musicreater/blob/pkgver/docs/%E5%8A%9F%E8%83%BD%E4%BD%BF%E7%94%A8%E8%AF%B4%E6%98%8E.md)。

## 结尾

### 作者\<*金羿*\>(Eilles)联系方式

1.  QQ       2647547478
2.  电邮      EillesWan2006@163.com W-YI_DoctorYI@outlook.com EillesWan@outlook.com
3.  微信      WYI_DoctorYI
4.  Telegram [@EillesWan](https://t.me/EillesWan)

### 作者\<*诸葛亮与八卦阵*\>(bgArray)联系方式

1. QQ       4740437765

**欢迎加群：[861684859](https://jq.qq.com/?_wv=1027&k=hpeRxrYr)**

**欢迎加群：[861684859](https://jq.qq.com/?_wv=1027&k=hpeRxrYr)**

**欢迎加群：[861684859](https://jq.qq.com/?_wv=1027&k=hpeRxrYr)**

（重要的事情说三遍）

**(有能力的同志麻烦给仓库star一下)**

**(有能力的同志麻烦给仓库star一下)**

**(有能力的同志麻烦给仓库star一下)**
